con

  _clkmode = xtal1 + pll16x
  _xinfreq = 4_194_340                                            ' use 5MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1 = 31
  TX1 = 30
  SDA = 29
  SCL = 28


con 

  #(-1), IS_ON, IS_OFF
  

con

   #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR       ' PST formmatting control
  #24, GOTOX, GOTOY, CLS


con

  M1_PWM = 8                                                     'set pins for motor pwm and direction
  M1_DIR = 9

  M2_PWM = 10
  M2_DIR = 11
  
var

  byte motor_setup                                               'variable which triggers an 'if' statement only the first time this                        
  long Stack1[30]                                                'object is called. 
  long Stack2[30] 
  long cogmotor1
  long cogmotor2

obj

  motors12 : "jm_dualmotor_ez"                                   'object which sends control signals to h-bridge drivers
  
 
pub main (reconstructed_data, Motor_Ident) | speed  , okmotor1', okmotor2

dira[24..26]~~
DIRA[7]~~

if(motor_setup == 0)                                             'this statement only triggers the first instance this method is called
   motors12.start(M1_PWM, M1_DIR, M2_PWM, M2_DIR, 2_500)         'sends motor variables to motor control object
   cognew(motorone(reconstructed_data), @Stack1)                 'starts new cogs to control both motors one and two
   cognew(motortwo(reconstructed_data), @Stack2)
   motor_setup := 1

if(Motor_Ident == 1)                                             '
   motorone(reconstructed_data)
   return

if(Motor_Ident == 2)
   motortwo(reconstructed_data)
   return

PUB motorone(reconstructed_data) | Rotation

if(reconstructed_data > 30)                                      'reconstructed data variable contains the rotation value 
  rotation := ((reconstructed_data - 30) * 100)                  'over #30 defines clockwise rotation
  motors12.Setspeed(0, 100)                                      'sets motor speed/direction by passing variables to 'jm_dualmotor'  
  !OUTA[7]                                                       'object, pauses program for determined time
  pause(rotation)                                                
  motors12.setspeed(0, 0)
                                                                 'stops motor
if(reconstructed_data < 30)                                      '<#30 defines ccwise rotation
  rotation := reconstructed_data * 100
  motors12.setspeed(0, -100)
  !OUTA[24] 
  Pause(rotation)
  motors12.setspeed(0, 0)

if(reconstructed_data > 70)
  motors12.Setspeed(0, 0)
return

PUB motortwo(reconstructed_data)  | Rotationm2
                                                                 'sets speed/dorection for motor two 
if(reconstructed_data > 30)
  rotationm2 := ((reconstructed_data - 30) * 100)     
  motors12.Setspeed(1, 100)
  !OUTA[25]
  pause(rotationm2)
  motors12.setspeed(1, 0)
  
if(reconstructed_data < 30)
  rotationm2 := reconstructed_data * 100 
  motors12.setspeed(1, -100)
  !OUTA[26]
  Pause(rotationm2)
  motors12.setspeed(1, 0)

if(reconstructed_data > 70)
  motors12.Setspeed(1, 0)
return
 

pub pause(ms) | t                                                'defines delay period

'' Delay program ms milliseconds

  if (ms > 0)                                                   ' if valid delay
    t := cnt - 1760                                             '  sync (remove call overhead)
    repeat ms                                                   '  run 1ms loops
      waitcnt(t += MS_001)   