con

  _clkmode = xtal1 + pll16x
  _xinfreq = 4_194_340                                            ' use 5MHz crystal
  

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000
    
VAR
  Long stack[30]
  Byte Temp
  Byte Motor_Ident
  
OBJ

  DATA : "get_data"

PUB Main(TempAddr)


DIRA[0..1]~                                            'P1 IS HANDSHAKE; P0 IS ENABLE...
DIRA[3..6]~                                            '4 bit -> DATA BUS
                                 
cognew(check_enable, @stack)  

repeat
  
  case Temp
    7:
      
      Motor_Ident := 1
      waitpeq(%00, %10, 0)                             'wait for ident enable to fall low                        
      DATA.readpins(Motor_ident)                        'call data function
      Temp := 0
        
    8:
                                                'waitpeq...first number state, second which pins
      Motor_Ident := 2
      waitpeq(%00, %10, 0)                               
      DATA.readpins(Motor_ident)
      Temp := 0
      
    3:
      Motor_Ident := 3
      waitpeq(%00, %10, 0)                               
      DATA.readpins(Motor_ident)
      Temp := 0
    4:
      Motor_Ident := 4
      waitpeq(%00, %10, 0)                               
      DATA.readpins(Motor_ident)
      Temp := 0

PUB check_enable
  
REPEAT
  waitpeq(%10, %10, 0)                                  'wait for initialisation enable (p1 -> RC6) to trigger
                                                     'wait for data enable...P0 -> RC0
    Temp := INA[6..3]                                   'read data pins into temp

    

                  




  